> ## Documentation Index
> Fetch the complete documentation index at: https://learn.servitly.com/llms.txt
> Use this file to discover all available pages before exploring further.
# Get thing-definitions
> Returns the list of thing-definitions configured in the DPS.
A thing-definition is the model of a connected product: it declares the metrics, alert-definitions, configuration-parameters, commands and dashboards shared by all the things based on it.
Thing-definitions can inherit the elements of a super thing-definition and can be composed through the parent thing-definition, so as to model products made of several connected sub-systems.
## OpenAPI
````json GET /inventory/thingDefinitions
{
"openapi": "3.1.0",
"info": {
"title": "Servitly DPS API",
"version": "1.0.0"
},
"servers": [
{
"url": "https://api.servitly-sandbox.com",
"description": "[AWS SANDBOX]"
},
{
"url": "https://api.servitly.com",
"description": "[AWS PRODUCTION Ireland]"
},
{
"url": "https://api-ap.servitly.com",
"description": "[AWS Hong Kong]"
},
{
"url": "https://azapi.servitly-dev.com",
"description": "[AZURE DEV Frankfurt]"
},
{
"url": "https://azapi.servitly-staging.com",
"description": "[AZURE STAGING Frankfurt]"
},
{
"url": "https://azapi.servitly.com",
"description": "[AZURE PRODUCTION Frankfurt]"
}
],
"security": [
{
"bearerAuth": []
}
],
"tags": [
{
"name": "ACTIONS"
},
{
"name": "ALERTS"
},
{
"name": "API GATEWAY"
},
{
"name": "AUTHENTICATION"
},
{
"name": "AUTHORIZATIONS"
},
{
"name": "CUSTOMERS"
},
{
"name": "DATA IMPORT / EXPORT"
},
{
"name": "EVENTS"
},
{
"name": "LOCATIONS"
},
{
"name": "MAINTENANCE"
},
{
"name": "MAPPING"
},
{
"name": "METRIC DATA"
},
{
"name": "MOBILE APP"
},
{
"name": "ORGANIZATION"
},
{
"name": "PARTNERS"
},
{
"name": "PRODUCT MODELS"
},
{
"name": "SPARE PARTS"
},
{
"name": "STATISTICS"
},
{
"name": "STORE ORDERS"
},
{
"name": "SUBSCRIPTIONS"
},
{
"name": "SUBSCRIPTIONS (OLD)"
},
{
"name": "THING CONTROL"
},
{
"name": "THING DEFINITIONS"
},
{
"name": "THING MANAGEMENT"
},
{
"name": "THINGS"
},
{
"name": "TICKETS"
},
{
"name": "USER TYPES"
},
{
"name": "USERS"
},
{
"name": "WORK SESSIONS"
}
],
"paths": {
"/inventory/thingDefinitions": {
"get": {
"summary": "Get thing-definitions",
"description": "Returns the list of thing-definitions configured in the DPS.
A thing-definition is the model of a connected product: it declares the metrics, alert-definitions, configuration-parameters, commands and dashboards shared by all the things based on it.
Thing-definitions can inherit the elements of a super thing-definition and can be composed through the parent thing-definition, so as to model products made of several connected sub-systems.",
"tags": [
"THING DEFINITIONS"
],
"parameters": [
{
"$ref": "#/components/parameters/tenantNameHeader"
}
],
"responses": {
"200": {
"description": "Successful operation.",
"content": {
"application/json": {
"schema": {
"type": "array",
"items": {
"$ref": "#/components/schemas/ThingDefinition"
}
}
}
}
},
"401": {
"$ref": "#/components/responses/NotAuthenticated"
},
"403": {
"$ref": "#/components/responses/NotAuthorized"
},
"404": {
"$ref": "#/components/responses/NotFound"
},
"429": {
"$ref": "#/components/responses/ApiLimit"
},
"500": {
"$ref": "#/components/responses/IntError"
}
}
}
}
},
"components": {
"parameters": {
"tenantNameHeader": {
"in": "header",
"name": "X-Servitly-Tenant",
"required": "true",
"schema": {
"type": "string",
"example": "{{tenantName}}"
},
"description": "The name of the tenant (e.g. acme)."
}
},
"schemas": {
"ThingDefinition": {
"type": "object",
"properties": {
"id": {
"type": "string",
"description": "The thing definition object identifier.",
"readOnly": "true"
},
"name": {
"type": "string",
"description": "The thing definition name."
},
"description": {
"type": "string",
"description": "The thing definition description."
},
"defaultThingName": {
"type": "string",
"description": "The placeholder-based value used for thing naming."
},
"nameMetricId": {
"type": "string",
"description": "The identifier of the metric providing the Thing name."
},
"serialNumberMetricId": {
"type": "string",
"description": "The identifier of the metric providing the Thing serial number."
},
"gpsPositionMetricId": {
"type": "string",
"description": "The identifier of the metric providing the Thing GPS position in the form \"latitude,longitude\"."
},
"thingDefinitionMetricId": {
"type": "string",
"description": "The identifier of the metric providing the name of the thing-definition used to dynamically change the thing-definition associated with a thing."
},
"superThingDefinitionId": {
"type": "string",
"description": "The identifier of the super thing-definition from which this thing-definition inherits elements (can be set only during creation)."
},
"parentThingDefinitionId": {
"type": "string",
"description": "The identifier of the parent thing-definition this thing-definition is part of."
},
"properties": {
"$ref": "#/components/schemas/Properties"
}
}
},
"Properties": {
"type": "object",
"description": "The set of properties providing additional details to the parent object.",
"additionalProperties": {
"type": "string"
},
"example": {
"foo": "abc",
"bar": "123"
}
}
},
"responses": {
"NotAuthenticated": {
"description": "User not authenticated.",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"message": {
"type": "string",
"description": "The error response.",
"example": "User not authenticated"
}
}
}
}
}
},
"NotAuthorized": {
"description": "User not authorized.",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"message": {
"type": "string",
"description": "The error response.",
"example": "User not authorized"
}
}
}
}
}
},
"NotFound": {
"description": "Resource was not found.",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"message": {
"type": "string",
"description": "The error response.",
"example": "Resource not found"
}
}
}
}
}
},
"ApiLimit": {
"description": "API call rate limit exceeded.",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"message": {
"type": "string",
"description": "The error response.",
"example": "API call rate limit exceeded"
}
}
}
}
}
},
"IntError": {
"description": "Internal server error.",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"message": {
"type": "string",
"description": "The error response.",
"example": "Internal Server Error"
}
}
}
}
}
}
},
"securitySchemes": {
"bearerAuth": {
"type": "http",
"scheme": "bearer"
}
}
}
}
````